package com.hw.admin.system.listener;

import org.apache.commons.io.monitor.FileAlterationMonitor;
import org.apache.commons.io.monitor.FileAlterationObserver;

public class FileMonitor {
    //监听事件
    private FileListener fileListener;
    //监听的文件路径
    private String path;
    private FileAlterationMonitor monitor;
    //默认监听的时间间隔
    private long defaultInterval = 10000L;

    public FileMonitor() {
    }

    public FileMonitor(String path) {
        this.path = path;
        this.monitor = new FileAlterationMonitor(defaultInterval);
    }

    public FileMonitor(String path, long interval) {
        this.path = path;
        this.monitor = new FileAlterationMonitor(interval);
    }

    public void setFileListener(FileListener fileListener) {
        this.fileListener = fileListener;
    }

    public void start() {
        if (monitor == null) {
            throw new IllegalStateException("Listener must not be null");
        }
        if (path == null) {
            throw new IllegalStateException("Listen path must not be null");
        }

        FileAlterationObserver observer = new FileAlterationObserver(path);
        observer.addListener(fileListener);
        monitor.addObserver(observer);
        try {
            monitor.start();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
